[
	define_type('GeoIPInfo');
		local(	'ip'			= (params->first ? params->first | client_ip),
				'country'		= string,
				'countrycode'	= string,
				'postalcode'	= string,
				'region'		= string,
				'regionname'	= string,
				'city'			= string,
				'metrocode'		= string,
				'areacode'		= string,
				'latitude'		= decimal,
				'longitude'		= decimal,
				'connection'	= array(-database='yourdb',-table='ip_blocks')
			);
	
		define_tag('onCreate');
			inline(self->connection,
					-sql=(	
							'select ipl.countrycode, ipl.region, ipl.city, cc.countryname, rc.regionname, ipl.metrocode, '
								'ipl.areacode, ipl.latitude, ipl.longitude, '
								'IF(ipl.postalCode is null or ipl.postalCode = "", '
									'( '
								 	'SELECT z.zip FROM zipcodes as z ORDER BY (DEGREES( '
										'ACOS( '
											'SIN(RADIANS(z.lat)) * SIN(RADIANS(ipl.latitude)) + '
											'COS(RADIANS(z.lat)) * COS(RADIANS(ipl.latitude)) * '
											'COS(RADIANS(z.lon - ipl.longitude)) '
											') '
										')) ASC LIMIT 0,1 '
									'), ipl.postalCode '
								') as postalCode '
							'from ip_blocks as ipb  '
							'left join ip_locations as ipl on ipb.location_id = ipl.location_id '
							'left join countrycodes as cc on cc.countrycode = ipl.countrycode '
							'left join regioncodes as rc on rc.regioncode = ipl.region '
							'where INET_ATON("' + self->ip + '") <= endIPNum order by endIPNum ASC limit 1;'
						)
					);
				self->country 		= field('countryname');
				self->countrycode 	= field('countrycode');
				self->postalcode 	= field('postalcode');
				self->region 		= field('region');
				self->regionname	= field('regionname');
				self->city 			= field('city');
				self->metrocode 	= field('metrocode');
				self->areacode		= field('areacode');
				self->latitude		= decimal(field('latitude'));
				self->longitude 	= decimal(field('longitude'));
			/inline;
		/define_tag;
		
		define_tag('onConvert');
			return(	'<pre>'
					'Country = ' 		self->country 		' \r'
					'Country code = '	self->countrycode 	' \r'
					'Postal code = '	self->postalcode 	' \r'
					'Region = '			self->region 		' \r'
					'Region name = '	self->regionname	' \r'
					'City = '			self->city 			' \r'
					'Metro code = '		self->metrocode 	' \r'
					'Area code = '		self->areacode		' \r'
					'Latitude = '		self->latitude		' \r'
					'Longitude = '		self->longitude 	' \r'
					'</pre>'
				);
		/define_tag;
	/define_type;
]